/***********************************************
 *
 * Angelscript Dumper v2.1 by learn_more
 * File: out\a177\script\cam_dump.as
 * Generated: 04-May-2012 01:24:06
 * Overgrowth.exe base: 0x400000
 *
 ***********************************************/

#include "shared_dump.as"


/***********************************************
 * Files that can access these (and included) functions/objects/properties:
 */

	// cam.as


/***********************************************
 * Global Functions:
 */

vec3 __cdecl LineLineIntersect(vec3,vec3,vec3,vec3)			// 'Overgrowth.exe' + 0x3a3a80 (0x7a3a80)


/***********************************************
 * Objects:
 */

class CollisionPoint
{		// size: 0x1c, flags:  asOBJ_VALUE asOBJ_POD asOBJ_APP_CLASS
	vec3 position;		// byteOffset: 0x0
	vec3 normal;		// byteOffset: 0xc
	int id;		// byteOffset: 0x18
};

class SphereCollision
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	float radius;		// byteOffset: 0x0
	vec3 position;		// byteOffset: 0x4
	vec3 adjusted_position;		// byteOffset: 0x10
//-----
	int NumContacts();		// 'Overgrowth.exe' + 0xba180 (0x4ba180)
	CollisionPoint GetContact(int);		// 'Overgrowth.exe' + 0xba1b0 (0x4ba1b0)
};

class ASCollisions
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	vec3 GetSlidingCapsuleCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3a3f00 (0x7a3f00)
	void GetSlidingSphereCollision(vec3,float);		// 'Overgrowth.exe' + 0x3a4640 (0x7a4640)
	void GetScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3a43d0 (0x7a43d0)
	void GetScaledSpherePlantCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3a42c0 (0x7a42c0)
	void GetSlidingScaledSphereCollision(vec3,float,vec3);		// 'Overgrowth.exe' + 0x3a46a0 (0x7a46a0)
	void GetCylinderCollision(vec3,float,float);		// 'Overgrowth.exe' + 0x3a4190 (0x7a4190)
	void GetSweptSphereCollision(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3a3eb0 (0x7a3eb0)
	void GetSweptSphereCollisionCharacters(vec3,vec3,float);		// 'Overgrowth.exe' + 0x3a4670 (0x7a4670)
	void GetSweptCylinderCollision(vec3,vec3,float,float);		// 'Overgrowth.exe' + 0x3a3f30 (0x7a3f30)
	void GetSweptBoxCollision(vec3,vec3,vec3);		// 'Overgrowth.exe' + 0x3a4060 (0x7a4060)
	void CheckRayCollisionCharacters(vec3,vec3);		// 'Overgrowth.exe' + 0x3a3ad0 (0x7a3ad0)
	vec3 GetRayCollision(vec3,vec3);		// 'Overgrowth.exe' + 0x3a35a0 (0x7a35a0)
};

class GUI
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	uint32 AddGUI(string, string, int, int, uint8);		// 'Overgrowth.exe' + 0x23d430 (0x63d430)
	void RemoveGUI(uint32);		// 'Overgrowth.exe' + 0x23c240 (0x63c240)
	void Execute(uint32, string);		// 'Overgrowth.exe' + 0x23c2a0 (0x63c2a0)
	void MoveTo(uint32, int, int);		// 'Overgrowth.exe' + 0x23d240 (0x63d240)
	string GetCallback(uint32);		// 'Overgrowth.exe' + 0x23d2b0 (0x63d2b0)
	void Update();		// 'Overgrowth.exe' + 0x2411e0 (0x6411e0)
};

class CameraObject
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	bool controlled;		// byteOffset: 0x84
	vec3 position;		// byteOffset: 0x88
	bool frozen;		// byteOffset: 0xd4
	vec3 velocity;		// byteOffset: 0xd8
	bool ignore_mouse_input;		// byteOffset: 0xe8
//-----
	void LoadParallaxScene(string, string);		// 'Overgrowth.exe' + 0x29a890 (0x69a890)
	void UnloadParallaxScene();		// 'Overgrowth.exe' + 0x29a840 (0x69a840)
};

class CameraAnimationReader
{		// size: 0x0, flags:  asOBJ_REF asOBJ_NOHANDLE
	void AttachTo(string);		// 'Overgrowth.exe' + 0x36aec0 (0x76aec0)
	vec3 GetPosition();		// 'Overgrowth.exe' + 0x36ad20 (0x76ad20)
	quaternion GetRotation();		// 'Overgrowth.exe' + 0x36ace0 (0x76ace0)
	float GetLens();		// 'Overgrowth.exe' + 0x36ad00 (0x76ad00)
	void Update();		// 'Overgrowth.exe' + 0x369ea0 (0x769ea0)
	bool valid();		// 'Overgrowth.exe' + 0x369260 (0x769260)
};



/***********************************************
 * Global Properties:
 */

ASCollisions col;
SphereCollision sphere_col;
GUI gui;
uint8 _GG_IGNORES_MOUSE;		// 'Overgrowth.exe' + 0x419ce0 (0x819ce0)
CameraObject co;
CameraAnimationReader camera_animation_reader;
